=== debian/changelog ===
uftrace (0.13-1) unstable; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <tar@debian.org>  Mon, 09 Jan 2023 13:39:25 +0100
