## uftrace 0.14

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION := 0.13
+VERSION := 0.14
 
 # Makefiles suck: This macro sets a default value of $(2) for the
 # variable named by $(1), unless the variable has been set by
@@ -27,10 +27,11 @@
 
 prefix ?= /usr/local
 bindir = $(prefix)/bin
-libdir = $(prefix)/lib
+libdir = $(prefix)/lib/uftrace
 etcdir = $(prefix)/etc
 mandir = $(prefix)/share/man
 docdir = $(srcdir)/doc
+completiondir = $(etcdir)/bash_completion.d
 
 ifeq ($(DOCLANG), ko)
   docdir = $(srcdir)/doc/ko
@@ -55,20 +56,26 @@
 
 export ARCH CC AR LD RM srcdir objdir LDFLAGS
 
-COMMON_CFLAGS := -D_GNU_SOURCE $(CFLAGS) $(CPPFLAGS)
+COMMON_CFLAGS := -std=gnu11 -D_GNU_SOURCE $(CFLAGS) $(CPPFLAGS)
 COMMON_CFLAGS += -iquote $(srcdir) -iquote $(objdir) -iquote $(srcdir)/arch/$(ARCH)
-COMMON_CFLAGS += -Wdeclaration-after-statement
-#CFLAGS-DEBUG = -g -D_GNU_SOURCE $(CFLAGS_$@)
-COMMON_LDFLAGS := -lrt -ldl -pthread -Wl,-z,noexecstack $(LDFLAGS)
+COMMON_CFLAGS += -W -Wall -Wno-unused-parameter -Wno-missing-field-initializers
+COMMON_CFLAGS += -Wdeclaration-after-statement -Wstrict-prototypes
+
+COMMON_LDFLAGS := -ldl -pthread -Wl,-z,noexecstack $(LDFLAGS)
+ifeq ($(ANDROID),)
+COMMON_LDFLAGS += -lrt
+else
+COMMON_LDFLAGS += -landroid
+endif
+
 ifneq ($(elfdir),)
   COMMON_CFLAGS  += -I$(elfdir)/include
   COMMON_LDFLAGS += -L$(elfdir)/lib
 endif
 
-COMMON_CFLAGS += -W -Wall -Wno-unused-parameter -Wno-missing-field-initializers
-
 C_STR_TARGET = utils/mermaid.js utils/mermaid.html
 C_STR_EXTENSION = cstr
+C_STR_OBJS := $(patsubst %,$(objdir)/%.$(C_STR_EXTENSION),$(C_STR_TARGET))
 
 #
 # Note that the plain CFLAGS and LDFLAGS can be changed
@@ -82,7 +89,9 @@
 TRACEEVENT_CFLAGS  = $(COMMON_CFLAGS) $(CFLAGS_$@) $(CFLAGS_traceevent)
 LIB_CFLAGS         = $(COMMON_CFLAGS) $(CFLAGS_$@) $(CFLAGS_lib)
 LIB_CFLAGS        += -fPIC -fvisibility=hidden -fno-omit-frame-pointer
+LIB_CFLAGS        += -fno-builtin -fno-tree-vectorize
 TEST_CFLAGS        = $(COMMON_CFLAGS) -DUNIT_TEST
+PYTHON_CFLAGS      = $(COMMON_CFLAGS) -fPIC
 
 UFTRACE_LDFLAGS    = $(COMMON_LDFLAGS) $(LDFLAGS_$@) $(LDFLAGS_uftrace)
 DEMANGLER_LDFLAGS  = $(COMMON_LDFLAGS) $(LDFLAGS_$@) $(LDFLAGS_demangler)
@@ -93,7 +102,7 @@
 TEST_LDFLAGS       = $(COMMON_LDFLAGS) -L$(objdir)/libtraceevent -ltraceevent
 
 ifeq ($(DEBUG), 1)
-  COMMON_CFLAGS += -O0 -g -DDEBUG_MODE=1
+  COMMON_CFLAGS += -O0 -g3 -DDEBUG_MODE=1 -Werror
 else
   COMMON_CFLAGS += -O2 -g -DDEBUG_MODE=0
 endif
@@ -158,7 +167,7 @@
 LIBMCOUNT_TARGETS := libmcount/libmcount.so libmcount/libmcount-fast.so
 LIBMCOUNT_TARGETS += libmcount/libmcount-single.so libmcount/libmcount-fast-single.so
 
-_TARGETS := uftrace libtraceevent/libtraceevent.a
+_TARGETS := uftrace libtraceevent/libtraceevent.a python/uftrace_python.so
 _TARGETS += $(LIBMCOUNT_TARGETS) libmcount/libmcount-nop.so
 _TARGETS += misc/demangler misc/symbols misc/dbginfo
 TARGETS  := $(patsubst %,$(objdir)/%,$(_TARGETS))
@@ -193,6 +202,11 @@
 BENCH_SRCS := $(srcdir)/misc/bench.c
 BENCH_OBJS := $(patsubst $(srcdir)/%.c,$(objdir)/%.o,$(BENCH_SRCS))
 
+PYTHON_SRCS := $(srcdir)/python/trace-python.c $(srcdir)/utils/debug.c
+PYTHON_SRCS += $(srcdir)/utils/utils.c $(srcdir)/utils/rbtree.c $(srcdir)/utils/shmem.c
+PYTHON_SRCS += $(wildcard $(srcdir)/utils/symbol-*.c)
+PYTHON_OBJS := $(patsubst $(srcdir)/%.c,$(objdir)/%.op,$(PYTHON_SRCS))
+
 UFTRACE_ARCH_OBJS := $(objdir)/arch/$(ARCH)/uftrace.o
 
 UFTRACE_HDRS := $(filter-out $(srcdir)/version.h,$(wildcard $(srcdir)/*.h $(srcdir)/utils/*.h))
@@ -211,6 +225,7 @@
 LIBMCOUNT_UTILS_SRCS += $(srcdir)/utils/auto-args.c $(srcdir)/utils/dwarf.c
 LIBMCOUNT_UTILS_SRCS += $(srcdir)/utils/hashmap.c $(srcdir)/utils/argspec.c
 LIBMCOUNT_UTILS_SRCS += $(srcdir)/utils/tracefs.c $(srcdir)/utils/socket.c
+LIBMCOUNT_UTILS_SRCS += $(srcdir)/utils/shmem.c
 LIBMCOUNT_UTILS_SRCS += $(wildcard $(srcdir)/utils/symbol*.c)
 LIBMCOUNT_UTILS_OBJS := $(patsubst $(srcdir)/utils/%.c,$(objdir)/libmcount/%.op,$(LIBMCOUNT_UTILS_SRCS))
 
@@ -284,15 +299,3 @@
 	@$(MAKE) -B -C $(srcdir)/arch/$(ARCH) $@
 
 $(UFTRACE_ARCH_OBJS): $(wildcard $(srcdir)/arch/$(ARCH)/*.[cS]) $(COMMON_DEPS)
-	@$(MAKE) -B -C $(srcdir)/arch/$(ARCH) $@
-
-$(objdir)/libtraceevent/libtraceevent.a: $(wildcard $(srcdir)/libtraceevent/*.[ch]) $(objdir)/.config
-	@$(MAKE) -C $(srcdir)/libtraceevent BUILD_SRC=$(srcdir)/libtraceevent BUILD_OUTPUT=$(objdir)/libtraceevent CONFIG_FLAGS="$(TRACEEVENT_CFLAGS)"
-
-$(objdir)/uftrace.o: $(srcdir)/uftrace.c $(objdir)/version.h c-str-conversion $(COMMON_DEPS)
-	$(QUIET_CC)$(CC) $(UFTRACE_CFLAGS) -c -o $@ $<
-
-$(objdir)/misc/demangler.o: $(srcdir)/misc/demangler.c $(objdir)/version.h $(COMMON_DEPS)
-	$(QUIET_CC)$(CC) $(DEMANGLER_CFLAGS) -c -o $@ $<
-
-$(objdir)/misc/symbols.o: $(srcdir)/misc/symbols.c $(objdir)/version.h $(COMMON_DEPS)
