=== debian/changelog ===
uftrace (0.14-1) unstable; urgency=medium

  * New upstream version.
  * Bump standards version to 4.6.2.

 -- Gürkan Myczko <tar@debian.org>  Tue, 20 Jun 2023 20:09:26 +0200
