=== debian/control ===
--- 
+++ 
@@ -3,10 +3,18 @@
 Priority: optional
 Maintainer: paul cannon <pik@debian.org>
 Uploaders: Gürkan Myczko <tar@debian.org>
-Build-Depends: debhelper-compat (= 12), libelf-dev, pandoc, python3,
- pkg-config, libpython3-dev, libdw-dev, libncursesw5-dev, libcapstone-dev,
- libluajit-5.1-dev, bash-completion
-Standards-Version: 4.6.1
+Build-Depends: debhelper-compat (= 12),
+ libelf-dev,
+ pandoc,
+ python3,
+ pkg-config,
+ libpython3-dev,
+ libdw-dev,
+ libncurses-dev,
+ libcapstone-dev,
+ libluajit-5.1-dev,
+ bash-completion,
+Standards-Version: 4.6.2
 Homepage: https://github.com/namhyung/uftrace
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/debian/uftrace.git
