## uftrace 0.15.2

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION := 0.14
+VERSION := 0.15
 
 # Makefiles suck: This macro sets a default value of $(2) for the
 # variable named by $(1), unless the variable has been set by
@@ -89,7 +89,7 @@
 TRACEEVENT_CFLAGS  = $(COMMON_CFLAGS) $(CFLAGS_$@) $(CFLAGS_traceevent)
 LIB_CFLAGS         = $(COMMON_CFLAGS) $(CFLAGS_$@) $(CFLAGS_lib)
 LIB_CFLAGS        += -fPIC -fvisibility=hidden -fno-omit-frame-pointer
-LIB_CFLAGS        += -fno-builtin -fno-tree-vectorize
+LIB_CFLAGS        += -fno-builtin -fno-tree-vectorize -DLIBMCOUNT
 TEST_CFLAGS        = $(COMMON_CFLAGS) -DUNIT_TEST
 PYTHON_CFLAGS      = $(COMMON_CFLAGS) -fPIC
 
@@ -99,7 +99,14 @@
 DBGINFO_LDFLAGS    = $(COMMON_LDFLAGS) $(LDFLAGS_$@) $(LDFLAGS_dbginfo)
 BENCH_LDFLAGS      = -Wl,-z,noexecstack $(LDFLAGS_$@) $(LDFLAGS_bench)
 LIB_LDFLAGS        = $(COMMON_LDFLAGS) $(LDFLAGS_$@) $(LDFLAGS_lib) -Wl,--no-undefined
-TEST_LDFLAGS       = $(COMMON_LDFLAGS) -L$(objdir)/libtraceevent -ltraceevent
+TEST_LDFLAGS       = $(COMMON_LDFLAGS)
+
+_DEFAULT_SANITIZERS := address,leak
+ifeq ($(ARCH), riscv64)
+  DEFAULT_SANITIZERS = $(_DEFAULT_SANITIZERS)
+else
+  DEFAULT_SANITIZERS = $(_DEFAULT_SANITIZERS),undefined
+endif
 
 ifeq ($(DEBUG), 1)
   COMMON_CFLAGS += -O0 -g3 -DDEBUG_MODE=1 -Werror
@@ -128,7 +135,7 @@
 endif
 
 ifeq ($(ASAN), 1)
-  ASAN_CFLAGS       := -O0 -g -fsanitize=address,leak,undefined
+  ASAN_CFLAGS       := -O0 -g -fsanitize=$(DEFAULT_SANITIZERS)
   UFTRACE_CFLAGS    += $(ASAN_CFLAGS)
   DEMANGLER_CFLAGS  += $(ASAN_CFLAGS)
   SYMBOLS_CFLAGS    += $(ASAN_CFLAGS)
@@ -139,7 +146,7 @@
 
 ifneq ($(SAN),)
   ifeq ($(SAN), all)
-    SAN_CFLAGS := -O0 -g -fsanitize=address,leak,undefined
+    SAN_CFLAGS := -O0 -g -fsanitize=$(DEFAULT_SANITIZERS)
   else
     SAN_CFLAGS := -O0 -g -fsanitize=$(SAN)
   endif
@@ -167,7 +174,7 @@
 LIBMCOUNT_TARGETS := libmcount/libmcount.so libmcount/libmcount-fast.so
 LIBMCOUNT_TARGETS += libmcount/libmcount-single.so libmcount/libmcount-fast-single.so
 
-_TARGETS := uftrace libtraceevent/libtraceevent.a python/uftrace_python.so
+_TARGETS := uftrace python/uftrace_python.so
 _TARGETS += $(LIBMCOUNT_TARGETS) libmcount/libmcount-nop.so
 _TARGETS += misc/demangler misc/symbols misc/dbginfo
 TARGETS  := $(patsubst %,$(objdir)/%,$(_TARGETS))
@@ -240,7 +247,6 @@
 CFLAGS_$(objdir)/mcount.op = -pthread
 CFLAGS_$(objdir)/cmds/record.o = -DINSTALL_LIB_PATH='"$(libdir)"'
 CFLAGS_$(objdir)/cmds/live.o = -DINSTALL_LIB_PATH='"$(libdir)"'
-LDFLAGS_$(objdir)/uftrace = -L$(objdir)/libtraceevent -ltraceevent -ldl
 
 LIBMCOUNT_FAST_CFLAGS := -DDISABLE_MCOUNT_FILTER
 LIBMCOUNT_SINGLE_CFLAGS := -DSINGLE_THREAD
@@ -298,4 +304,3 @@
 $(LIBMCOUNT_ARCH_OBJS): $(wildcard $(srcdir)/arch/$(ARCH)/*.[cS]) $(LIBMCOUNT_DEPS)
 	@$(MAKE) -B -C $(srcdir)/arch/$(ARCH) $@
 
-$(UFTRACE_ARCH_OBJS): $(wildcard $(srcdir)/arch/$(ARCH)/*.[cS]) $(COMMON_DEPS)
