=== debian/changelog ===
uftrace (0.15.2-1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:29:41 +1100

uftrace (0.15.2-1build1) noble; urgency=medium

  * No-change rebuild against libelf1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 01 Mar 2024 01:04:54 +0000

uftrace (0.15.2-1) unstable; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <tar@debian.org>  Fri, 26 Jan 2024 08:54:48 +0100

uftrace (0.15.1-3) unstable; urgency=medium

  * d/control: build-depends exclude libluajit-5.1-dev from riscv64 arch.

 -- Gürkan Myczko <tar@debian.org>  Sun, 21 Jan 2024 16:18:07 +0100

uftrace (0.15.1-2) unstable; urgency=medium

  * d/control: add libunwind-dev, and libtraceevent-dev to build-depends.
  * Enable archs armel and armhf.

 -- Gürkan Myczko <tar@debian.org>  Sat, 20 Jan 2024 13:02:01 +0100

uftrace (0.15.1-1) unstable; urgency=medium

  * New upstream version.

 -- Gürkan Myczko <tar@debian.org>  Sun, 14 Jan 2024 16:03:04 +0100

uftrace (0.15-1) unstable; urgency=medium

  * New upstream version.
  * d/copyright: add myself to debian/, bump years,
    add Upstream-Contact, drop libtraceevent/ part.
  * d/patches/: inactivated.
  * d/not-installed: added.
  * d/control: enable build on riscv64.

 -- Gürkan Myczko <tar@debian.org>  Wed, 10 Jan 2024 07:28:25 +0100
