=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: uftrace
 Section: utils
 Priority: optional
-Maintainer: paul cannon <pik@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: paul cannon <pik@debian.org>
 Uploaders: Gürkan Myczko <tar@debian.org>
 Build-Depends: debhelper-compat (= 12),
  libelf-dev,
@@ -12,7 +13,9 @@
  libdw-dev,
  libncurses-dev,
  libcapstone-dev,
- libluajit-5.1-dev,
+ libluajit-5.1-dev [!riscv64],
+ libunwind-dev,
+ libtraceevent-dev,
  bash-completion,
 Standards-Version: 4.6.2
 Homepage: https://github.com/namhyung/uftrace
@@ -21,7 +24,7 @@
 Vcs-Browser: https://salsa.debian.org/debian/uftrace
 
 Package: uftrace
-Architecture: amd64 arm64 i386
+Architecture: amd64 arm64 armel armhf i386 riscv64
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: Traces and analyzes execution of programs written in C/C++
  The uftrace tool is intended for tracing and analyzing the execution of
