## uftrace 0.16

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-VERSION := 0.15
+VERSION := 0.16
 
 # Makefiles suck: This macro sets a default value of $(2) for the
 # variable named by $(1), unless the variable has been set by
@@ -93,13 +93,13 @@
 TEST_CFLAGS        = $(COMMON_CFLAGS) -DUNIT_TEST
 PYTHON_CFLAGS      = $(COMMON_CFLAGS) -fPIC
 
-UFTRACE_LDFLAGS    = $(COMMON_LDFLAGS) $(LDFLAGS_$@) $(LDFLAGS_uftrace)
+UFTRACE_LDFLAGS    = $(COMMON_LDFLAGS) $(LDFLAGS_$@) $(LDFLAGS_uftrace) -lm
 DEMANGLER_LDFLAGS  = $(COMMON_LDFLAGS) $(LDFLAGS_$@) $(LDFLAGS_demangler)
 SYMBOLS_LDFLAGS    = $(COMMON_LDFLAGS) $(LDFLAGS_$@) $(LDFLAGS_symbols)
 DBGINFO_LDFLAGS    = $(COMMON_LDFLAGS) $(LDFLAGS_$@) $(LDFLAGS_dbginfo)
 BENCH_LDFLAGS      = -Wl,-z,noexecstack $(LDFLAGS_$@) $(LDFLAGS_bench)
 LIB_LDFLAGS        = $(COMMON_LDFLAGS) $(LDFLAGS_$@) $(LDFLAGS_lib) -Wl,--no-undefined
-TEST_LDFLAGS       = $(COMMON_LDFLAGS)
+TEST_LDFLAGS       = $(COMMON_LDFLAGS) -lm
 
 _DEFAULT_SANITIZERS := address,leak
 ifeq ($(ARCH), riscv64)
@@ -212,7 +212,7 @@
 PYTHON_SRCS := $(srcdir)/python/trace-python.c $(srcdir)/utils/debug.c
 PYTHON_SRCS += $(srcdir)/utils/utils.c $(srcdir)/utils/rbtree.c $(srcdir)/utils/shmem.c
 PYTHON_SRCS += $(wildcard $(srcdir)/utils/symbol-*.c)
-PYTHON_OBJS := $(patsubst $(srcdir)/%.c,$(objdir)/%.op,$(PYTHON_SRCS))
+PYTHON_OBJS := $(patsubst $(srcdir)/%.c,$(objdir)/%.oy,$(PYTHON_SRCS))
 
 UFTRACE_ARCH_OBJS := $(objdir)/arch/$(ARCH)/uftrace.o
