=== debian/changelog ===
uftrace (0.16-1build2) plucky; urgency=medium

  * No-change rebuild for Python 3.13 as the default.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 03 Jan 2025 12:02:34 +0100

uftrace (0.16-1build1) plucky; urgency=medium

  * No-change rebuild for capstone.

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Tue, 31 Dec 2024 14:16:41 +0000

uftrace (0.16-1) unstable; urgency=medium

  * New upstream version.
  * Bump standards version to 4.7.0.
  * d/control: build-depends update pkg-config to pkgconf.

 -- Alex Myczko <tar@debian.org>  Tue, 30 Apr 2024 04:47:26 +0200
