=== tests/Makefile ===
--- 
+++ 
@@ -1,10 +1,13 @@
-TEST_CFLAGS  += -g -include $(srcdir)/tests/unittest.h -Wno-sign-compare
+TEST_CFLAGS  += -g -include $(srcdir)/tests/unittest.h -Wno-sign-compare $(CFLAGS_$@)
 
 UNIT_TEST_SRC := $(srcdir)/uftrace.c
 UNIT_TEST_SRC += $(wildcard $(srcdir)/cmds/*.c)
 UNIT_TEST_SRC += $(wildcard $(srcdir)/utils/*.c)
 UNIT_TEST_SRC += $(wildcard $(srcdir)/arch/$(ARCH)/*.c)
 UNIT_TEST_SRC += $(wildcard $(srcdir)/libmcount/*.c)
+ifneq ($(findstring HAVE_LIBPYTHON, $(TEST_CFLAGS)), )
+UNIT_TEST_SRC += $(wildcard $(srcdir)/python/*.c)
+endif
 UNIT_TEST_OBJ := $(patsubst $(srcdir)/%.c,$(objdir)/%.ot,$(UNIT_TEST_SRC))
 UNIT_TEST_OBJ := $(filter-out %-nop.ot,$(UNIT_TEST_OBJ))
 
@@ -17,6 +20,7 @@
 UNIT_TEST_OBJ_VERSION := $(objdir)/cmds/script.ot $(objdir)/cmds/tui.ot
 UNIT_TEST_OBJ_VERSION += $(objdir)/cmds/dump.ot   $(objdir)/cmds/info.ot
 UNIT_TEST_OBJ_VERSION += $(objdir)/libmcount/mcount.ot
+
 
 FULL_WORKER := -j $(shell getconf _NPROCESSORS_ONLN || echo 1)
 
@@ -31,9 +35,15 @@
 test_all: unittest
 	$(QUIET_TEST)./unittest $(TESTARG) $(UNITTESTARG)
 	$(QUIET_TEST)./runtest.py $(WORKER) $(TESTARG) $(RUNTESTARG)
+ifneq ($(findstring HAVE_LIBPYTHON, $(TEST_CFLAGS)), )
+	$(QUIET_TEST)./runtest.py -P $(WORKER) $(TESTARG) $(PYTESTARG)
+endif
 
 test_run:
 	$(QUIET_TEST)./runtest.py $(WORKER) $(TESTARG) $(RUNTESTARG)
+
+test_python:
+	$(QUIET_TEST)./runtest.py -P $(WORKER) $(TESTARG) $(PYTESTARG)
 
 test_unit: unittest
 	$(QUIET_TEST)./unittest $(TESTARG) $(UNITTESTARG)
@@ -50,4 +60,4 @@
 	$(call QUIET_CLEAN, test)
 	@rm -f *.o *.so *.pyc t-* unittest $(UNIT_TEST_OBJ)
 
-.PHONY: clean test test_run test_unit
+.PHONY: clean test test_run test_unit test_python
