=== debian/changelog ===
uftrace (0.17-1) unstable; urgency=medium

  * New upstream version.

 -- Alex Myczko <tar@debian.org>  Fri, 24 Jan 2025 13:13:04 +0000
