## uftrace 0.18

=== debian/changelog ===
uftrace (0.18-1) unstable; urgency=medium

  * New upstream version.

 -- Alex Myczko <tar@debian.org>  Fri, 05 Sep 2025 10:47:57 -0500
